#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/AsciiText.h>

Widget d_popup, diallist;
char *d_list[5];
char *buf;
int d_list_no;
extern int siofd, pipe_fd[2];

extern struct dial{
  char name[10];
  char phon[20];
  int s_log;
}list[5];

void D_select( w, client_data, call_data )  /*  dial select  */
Widget  w;
caddr_t client_data;
caddr_t call_data;
{
  XawListReturnStruct  *f_ret;

  f_ret = (XawListReturnStruct *)call_data;

  d_list_no = f_ret->list_index;

}

void Dial_popdown()
{
  XtPopdown( d_popup );
}

void Dial( w, client_data, call_data )  /*  start dialing  */
Widget  w;
caddr_t client_data;
caddr_t call_data;
{
  unsigned char ch_cr, p_flg;
  int  dial_len;

  dial_len = strlen( list[d_list_no].phon );
  write( siofd, &list[d_list_no].phon, dial_len );
  ch_cr = 0x0d;
  write( siofd, &ch_cr, 1 );  /* output CR */
  if( list[d_list_no].s_log == 1 )
  {
    p_flg = 0x02;
    write(pipe_fd[1], &p_flg, 1);    /* auto log save */
  }

  Dial_popdown( d_popup );
}

void Open_dial_popup(w)  /* popup text list */
Widget w;
{
  XtPopup( d_popup, XtGrabExclusive );
}

void Dial_list() /* set filename to buffer */
{
  char list_buf[35];
  int list_no;

  for( list_no = 0; list_no <= 4; list_no ++ )
  {
    sprintf( list_buf, "%d  %-10s %-20s",
         list_no+1, list[list_no].name, list[list_no].phon );
    buf = (char *) calloc(strlen(list_buf) + 1, sizeof(char));
    strcpy( buf, list_buf );
    d_list[list_no] = buf;
  }

  XawListChange( diallist, d_list, 5, 0, True );

  return;
}

void Delete_dialpop( w, event, params, num_params )  /*  Delete dial popup  */
Widget w;
XEvent *event;
String *params;
int    num_params;
{
  Dial_popdown();
}

void Dialpopup(parent)
Widget parent;
{
  Widget  box, done, close;
  static XtActionsRec actions[] = {{"delete", Delete_dialpop}};
  static Atom wm_delete_window;

  d_popup  = XtCreatePopupShell("popup", topLevelShellWidgetClass, parent,
			      NULL, 0);
  box    = XtCreateManagedWidget("box", boxWidgetClass, d_popup,
				    NULL, 0);
  diallist   = XtVaCreateManagedWidget("dialList", listWidgetClass, box,
				       XtNdefaultColumns, 1,
				       NULL);
  Dial_list();

  done  = XtCreateManagedWidget("done", commandWidgetClass, box,
				   NULL, 0);
  close  = XtCreateManagedWidget("close", commandWidgetClass, box,
				   NULL, 0);

  XtAddCallback(diallist, XtNcallback, D_select, NULL);
  XtAddCallback(done, XtNcallback, Dial, NULL);
  XtAddCallback(close, XtNcallback, Dial_popdown, NULL);

  XtAddActions( actions, XtNumber(actions) );
  XtOverrideTranslations( d_popup,
	      XtParseTranslationTable("<Message>WM_PROTOCOLS: delete()"));
  wm_delete_window = XInternAtom(XtDisplay(d_popup), "WM_DELETE_WINDOW", False);

  XtRealizeWidget( d_popup );

  XSetWMProtocols( XtDisplay(d_popup), XtWindow(d_popup), &wm_delete_window, 1 );
}
