#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/AsciiText.h>

void Exec_shell();

extern int pid, pipe_fd[2];
extern char *portname;
Widget s_popup;

static XtActionsRec action_shell[] =
{  {"exec_shell",Exec_shell},
};

static char Translations_shell[] = "<Key>Return: exec_shell()";

void Open_shell_popup()
{
  XtPopup( s_popup, XtGrabExclusive );
}

void Shell_popdown()
{
  XtPopdown( s_popup );
}

void Exec_shell( w, event, params, num_params )
Widget  w;
XEvent  *event;
String  *params;
int     num_params;
{
  String str;
  int i, ch_len;
  char stop_flg, *exebuf, ridai[26];

  stop_flg = 0x40;
  write(pipe_fd[1], &stop_flg, 1);

  XtVaGetValues(w, XtNstring, &str, NULL);

  ch_len = strlen(str);
  if( str[0] == '>' )
  {
    memset( ridai, 0, sizeof(ridai) );
    sprintf( ridai,"< %s > %s", portname, portname );
    for( i = 0; i < ch_len; i ++ )
    {
      str[i] = str[i+1];
    }
    exebuf = (char*)malloc((ch_len + strlen(ridai)) * sizeof(char));
    sprintf( exebuf, "%s %s", str, ridai );
  }
  else
  {
    exebuf = (char*)malloc((ch_len+1) * sizeof(char));
    strcpy( exebuf, str );
  }

  system( exebuf );

  free( exebuf );

  kill( pid, SIGCONT );

  XtVaSetValues( w, XtNstring, "", NULL );

  Shell_popdown( s_popup );
}

void Delete_shellpop( w, event, params, num_params )  /*  Delete shell popup  */
Widget w;
XEvent *event;
String *params;
int    num_params;
{
  Shell_popdown();
}

void Shellpopup(parent)
Widget parent;
{
  Widget  box, command;
  static XtActionsRec actions[] = {{"delete", Delete_shellpop}};
  static Atom wm_delete_window;

  XtTranslations trans_table;

  s_popup  = XtCreatePopupShell("popup", topLevelShellWidgetClass, parent,
			      NULL, 0);
  box    = XtCreateManagedWidget("box", boxWidgetClass, s_popup,
				    NULL, 0);
  command  = XtVaCreateManagedWidget("fileview", asciiTextWidgetClass, box,
				     XtNeditType, XawtextEdit,
				     XtNlength, 128,
				     XtNwidth, 300,
				     NULL);
  XtSetKeyboardFocus( box, command );
  XtAddActions(action_shell,XtNumber(action_shell));
  trans_table = XtParseTranslationTable(Translations_shell);
  XtOverrideTranslations(command, trans_table);

  XtAddActions( actions, XtNumber(actions) );
  XtOverrideTranslations( s_popup,
	      XtParseTranslationTable("<Message>WM_PROTOCOLS: delete()"));
  wm_delete_window = XInternAtom(XtDisplay(s_popup), "WM_DELETE_WINDOW", False);

  XtRealizeWidget( s_popup );

  XSetWMProtocols( XtDisplay(s_popup), XtWindow(s_popup), &wm_delete_window, 1 );
}
