#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <termios.h>
#include <sys/stat.h>
#include <sys/fcntl.h>
#include <sys/types.h>

struct termios sio, sio_buf;
extern int siofd;
struct dial{
  char name[10];
  char phon[20];
  int s_log;
}list[5];

char *port = "/dev/cuaa1";
char *portname;
#define SIO_SPEED B38400

int list_no;

extern int default_kanji_code;

int Setspeed( spd_flg )   /*  set input/output speed  */
int spd_flg;
{
  int spd;

  switch ( spd_flg )
  {
  case 0:      spd = B0;      break;
  case 50:     spd = B50;     break;
  case 75:     spd = B75;     break;
  case 110:    spd = B110;    break;
  case 134:    spd = B134;    break;
  case 150:    spd = B150;    break;
  case 200:    spd = B200;    break;
  case 300:    spd = B300;    break;
  case 600:    spd = B600;    break;
  case 1200:   spd = B1200;   break;
  case 1800:   spd = B1800;   break;
  case 2400:   spd = B2400;   break;
  case 4800:   spd = B4800;   break;
  case 9600:   spd = B9600;   break;
  case 19200:  spd = B19200;  break;
  case 38400:  spd = B38400;  break;
  case 57600:  spd = B57600;  break;
/*case 76800:  spd = B76800;  break;*/
  case 115200: spd = B115200; break;
  case 230400: spd = B230400; break;
  default:     spd = EXTA;    break;
  }

  return( spd );
}

int Initsio()
{
  portname = port;

  if((siofd = open( portname, O_RDWR )) == -1)
  {
    printf("cannnot open %s\n", port);
    return(0);
  };

  if(tcgetattr(siofd, &sio) == -1)
  {
    printf("tcgetattr error\n");
  };
  sio_buf = sio;

  /* setup sio speed */
  cfsetispeed( &sio, SIO_SPEED );
  cfsetospeed( &sio, SIO_SPEED );

  sio.c_iflag &= 0x00;
  sio.c_iflag &= ~( IXON );     /*  XON flow control OFF  */
  sio.c_iflag &= ~( IXOFF );    /*  XOFF flow control OFF  */
  sio.c_iflag |= (IGNBRK | IGNPAR);  /* ignore BREAK & parity */
  sio.c_iflag &= ~(ISTRIP | BRKINT);/* 8th bit off & non-break to SIGINTR */

  sio.c_oflag &= 0x00;

  sio.c_cflag &= 0x00;
  sio.c_cflag &= ~( CSIZE | PARENB ); /* character size mask & parity enable */
  sio.c_cflag |= ( CS8 );       /*  character size 8bit  */
  sio.c_cflag |= ( CRTSCTS );   /*  CTS/RTS flow control ON  */
  sio.c_cflag |= (CREAD | CLOCAL); /* enable receiver & ignore modem status */

  sio.c_lflag &= 0x00;

  if(tcsetattr(siofd, TCSANOW, &sio) == -1)
  {
    printf("tcsetattr error\n");
    return(0);
  };
  return(1);
}

int Inst_flg( command, flg )
char *command;
char *flg;
{
  if( strcmp(command, "PORT") == 0 )
  {
    portname = (char*)malloc((strlen(flg)+1)*sizeof(char));
    strcpy(portname,flg);
    if((siofd = open( portname, O_RDWR )) == -1)
    {
      printf("cannnot open %s\n",portname);
      return(0);
    };

    if(tcgetattr(siofd, &sio) == -1)
    {
      printf("tcgetattr error\n");
      return(0);
    };
    sio_buf = sio;

    sio.c_iflag &= 0x00;
    sio.c_iflag |= (IGNBRK | IGNPAR);  /* ignore BREAK & parity */
    sio.c_iflag &= ~(ISTRIP | BRKINT);/* 8th bit off & non-break to SIGINTR */

    sio.c_oflag &= 0x00;

    sio.c_cflag &= 0x00;
    sio.c_cflag |= (CREAD | CLOCAL);/* enable receiver & ignore modem status */

    sio.c_lflag &= 0x00;
  }
  else if( strcmp(command, "XON/XOFF") == 0 )
  {
    if( strcmp(flg, "ON") == 0  )
    {
      sio.c_iflag |=  ( IXON );     /*  XON flow control ON  */
      sio.c_iflag |=  ( IXOFF );    /*  XOFF flow control ON  */
    }
    else if( strcmp(flg, "OFF") == 0 )
    {
      sio.c_iflag &= ~( IXON );     /*  XON flow control OFF  */
      sio.c_iflag &= ~( IXOFF );    /*  XOFF flow control OFF  */
    }
  }
  else if( strcmp(command, "CTS/RTS") == 0 )
  {
    if( strcmp(flg, "ON") == 0 )
      sio.c_cflag |= ( CRTSCTS );   /*  CTS/RTS flow control ON  */
    else if( strcmp(flg, "OFF") == 0 )
      sio.c_cflag &= ~( CRTSCTS );   /*  CTS/RTS flow control OFF  */
  }
  else if( strcmp(command, "CHSIZE") == 0 )
  {
    sio.c_cflag &= ~( CSIZE );      /* character size mask */
    if( strcmp(flg, "7") == 0 )
      sio.c_cflag |= ( CS7 );       /*  character size 7bit  */
    else if( strcmp(flg, "8") == 0 )
      sio.c_cflag |= ( CS8 );       /*  character size 8bit  */
  }
  else if( strcmp(command, "PARITY") == 0 )
  {
    if( strcmp(flg, "ON") == 0  )
      sio.c_cflag |= ( PARENB );        /* parity enable  */
    else if( strcmp(flg, "OFF") == 0  )
      sio.c_cflag &= ~( PARENB );       /* parity disable  */
  }
  else if( strcmp(command, "SPEED") == 0 )
  {
    cfsetispeed( &sio, Setspeed( atoi(flg) ) );
    cfsetospeed( &sio, Setspeed( atoi(flg) ) );
  }
  else if( strcmp(command, "HOSTNAME") == 0 )
  {
    strcpy(list[list_no].name,flg);
  }
  else if( strcmp(command, "PHONE") == 0 )
  {
    strcpy(list[list_no].phon,flg);
  }
  else if( strcmp(command, "SAVELOG") == 0 )
  {
    if( strcmp(flg, "ON") == 0  )
      list[list_no].s_log = 1;
    else
      list[list_no].s_log = 0;
    list_no ++;
  }
  else if( strcmp(command, "KANJI_CODE") == 0 )
  {
    default_kanji_code = atoi(flg);
  }
  return(1);
}

void Read_ini_file()
{
  FILE  *fp;
  int   i, j;
  char  buf[256],
        cbuf[16],
        fbuf[16],
        *pathdir,
        *pathname,
        *command,
        *flg;

  list_no = 0;
  pathdir = getenv("HOME");
  pathname = (char*)malloc((strlen(pathdir)+9)*sizeof(char));
  strcpy(pathname,pathdir);
  strcat(pathname,"/siminit");

  if((fp = fopen( pathname, "r" )) == NULL )
  {
    if( Initsio() == 0 )
      exit(0);
    printf("cannnot open siminit\n");
    return;
  }

  while( fgets( buf, 255, fp ) != NULL )
  {
    if( buf[0] == '#' || buf[0] == '\0' )
      continue;

    memset( cbuf, 0, sizeof(cbuf) );
    for( i = 0; buf[i] != 0x20; i++ )
      cbuf[i] = buf[i];

    command = (char*)malloc((strlen(cbuf)+1)*sizeof(char));
    strcpy(command, cbuf);

    memset( fbuf, 0, sizeof(fbuf) );
    j = 0;
    for( ; buf[i] != 0x0a; i++ )
    {
      if( buf[i] == '#' )
	break;
      else if( buf[i] == 0x20 )
	continue;
      fbuf[j] = buf[i];
      j ++;
    }

    flg = (char*)malloc((strlen(fbuf)+1)*sizeof(char));
    strcpy(flg, fbuf);

    if( Inst_flg( command, flg ) == 0 )
      exit(0);

    free( command );
    free( flg );
  }

  if(tcsetattr(siofd, TCSANOW, &sio) == -1)
  {
    printf("tcsetattr error\n");
  };

  free( pathname );
  fclose( fp );

}

void Hangup()  /*  modem hangup  */
{
  char ch_cr;
  char *ch_hang1 = "+++";
  char *ch_hang2 = "ATH";

  sleep(2);
  write(siofd, ch_hang1, 3);

  sleep(2);
  write(siofd, ch_hang2, 3);
  ch_cr = 0x0d;
  write(siofd, &ch_cr, 1);
}
